package com.maroontress.coverture;

/**
   ؿդΥåǤåˤϸꡢϥ֥åФ
   λ֥åޤ
*/
public final class Arc {

    /**
       ѥ˥󥰥ĥ꡼륨åɽե饰Ǥ
    */
    private static final int FLAG_ON_TREE = 0x1;

    /**
       Υåɽե饰ǤΥåϡ㳰longjmp()ˤ
       ơߤδؿȴ䡢exit()ʤɤΤ褦ʤؿ
       θƤӽФηϩɽޤ
    */
    private static final int FLAG_FAKE = 0x2;

    /**
       åʬʤäϩǤ뤳Ȥɽե饰Ǥ
    */
    private static final int FLAG_FALL_THROUGH = 0x4;

    /** ϥ֥åǤ */
    private Block start;

    /** λ֥åǤ */
    private Block end;

    /**
       åΥե饰ǤFLAG_ON_TREE, FLAG_FAKE, FLAG_FALL_THROUGH
       ¤ˤʤޤ
    */
    private int flags;

    /**
       Arc is for a function that abnormally returns: Υå
       ؿθƤӽФʤȤ򼨤ޤ
    */
    private boolean callNonReturn;

    /**
       Arc is for catch/setjmp: ΥåιԤ褬catchޤ
       setjmp()Ǥ뤳Ȥ򼨤ޤ
    */
    private boolean nonLocalReturn;

    /** ̤ */
    private int count;

    /** ̤ */
    private boolean countValid;

    /**
       åޤ󥹥󥹤ϳϥ֥åΡֽФ
       åסλ֥åΡ륨åפɲäޤ

       @param start ϥ֥å
       @param end λ֥å
       @param flags ե饰
    */
    public Arc(final Block start, final Block end, final int flags) {
	this.start = start;
	this.end = end;
	this.flags = flags;
	start.addOutArc(this);
	end.addInArc(this);
	if (isFake()) {
	    if (start.getId() != 0) {
		/*
		  Exceptional exit from this function, the source
		  block must be a call.
		*/
		start.setCallSite(true);
		callNonReturn = true;
	    } else {
		/*
		  Non-local return from a callee of this function. The
		  destination block is a catch or setjmp.
		*/
		end.setNonLocalReturn(true);
		nonLocalReturn = true;
	    }
	}
    }

    /**
       åѥ˥󥰥ĥ꡼뤫ɤޤ

       @return ѥ˥󥰥ĥ꡼trueǤʤ
       false
    */
    public boolean isOnTree() {
	return (flags & FLAG_ON_TREE) != 0;
    }

    /**
       åΥåɤޤ

       @return ΥåξtrueǤʤfalse
    */
    public boolean isFake() {
	return (flags & FLAG_FAKE) != 0;
    }

    /**
       åʬʤäϩǤ뤫ɤޤ

       @return åʬʤäϩξtrueǤʤ
       false
    */
    public boolean isFallThrough() {
	return (flags & FLAG_FALL_THROUGH) != 0;
    }

    /**
       åexit()ʤɤΤ褦ʤؿθƤӽФǤ뤫ɤ
       ޤ

       @return ʤؿθƤӽФξtrueǤʤfalse
    */
    public boolean isCallNonReturn() {
	return callNonReturn;
    }

    /**
       åιԤ褬catchޤsetjmp()Ǥ뤫ɤޤ

       @return åιԤ褬catchޤsetjmp()Ǥtrue
       Ǥʤfalse
    */
    public boolean isNonLocalReturn() {
	return nonLocalReturn;
    }

    /**
       åνλ֥åޤ

       @return λ֥å
    */
    public Block getEnd() {
	return end;
    }
}
